#version 110
#define float4 vec4
#define float3 vec3
#define float2 vec2
#define oUV gl_TexCoord[0]
#define tex3D texture3D
#define tex2D texture2D
#define tex1D texture1D

varying vec3 normal;
varying vec4 normal2;
//varying vec4 position;
varying vec4 projection_position;
varying vec4 ShadowPosZ;
varying vec4 Color;

varying vec4 projection_from_camera;

varying vec2 UVcoordinates;
uniform vec4 Plane1;
uniform vec4 Plane2;
uniform vec4 Plane3;
uniform vec4 Plane4;
// Position of vertex in world space before rotation
varying vec4 Position_Pre;

in vec3 TheColor;
uniform mat4 ProjectionMatrix;
				uniform sampler2D texture2d_1;
				uniform sampler2D texture2d_2;
				uniform sampler2D texture2d_3;
				uniform sampler2D texture2d_blob;
				uniform samplerCube texture2d_cube;
				/*				uniform sampler3D texture3d_2;
				uniform sampler1D texture_transfer_function;
				uniform sampler1D texture_palette_function;

					
				uniform float3 VolumeSize;
				uniform float3 RelativeSize;
				uniform float3 Registration_Offset;
				uniform float pet_alpha_blending;
				uniform float3 MousePos;
				uniform int Projection_mode;
uniform float3 InVolumePosition;
				uniform float3 Windowing_Levels;

				uniform float isosurface;
uniform float Sharpening;

*/



	uniform float PosY;
varying float Fade;



void main (void) 
{

vec4 Final_Color;
	// discard segments
if (sin(projection_position.y*50.5)*cos(projection_position.x*50.5)>0.7) discard;


float4 nnormal= (normal.xyzz);
float4 projection_pos=projection_position;

projection_pos=ShadowPosZ / ShadowPosZ.w ;;


vec4 ReflCol=texture2D (texture2d_3,projection_pos.st);

// Bump mapping?
//float3 BumpNormal=tex2D (texture2d_3,UVcoordinates.xy*0.4).xyz*2.0-vec3 (1.0);


// calculate ambient
float4 Ambient_Color=vec4 (0.2);

// calculate diffuse color
vec3 normalized_normal=normalize(normal2.xyz);
float dott=dot(normalized_normal.xyz,vec3 (0.0,0.0,1.0));
dott=abs (dott);
dott=clamp (dott,0.0,1.0);
dott=0.5+0.5*pow(dott,4.0);
float4 Diffuse_Color=vec4 (dott);
//*vec4 (0.3,0.6,1.0,1.0);

// calculate specular 
vec3 H=vec3 (0.0,0.0,1.0)+vec3 (0.3,-0.1,0.0);
H=normalize (H);

dott=dot(normalized_normal,H);
dott=clamp (dott,0.0,1.0);
dott=pow(dott,10.0);
float4 Specular_Color=vec4 (dott)*vec4 (1.0);


// combine all
Final_Color=Ambient_Color+Diffuse_Color*0.0+Specular_Color*0;


Final_Color=Diffuse_Color*Color;
Final_Color=Color;



Final_Color*=1.0;

//Final_Color=Color;

//Final_Color=vec4 (0.1,0.3,1.5,1.0);
//Final_Color=Color;
//Final_Color=vec4 (1.0,0.5,0.3,1.0)*1.0;


//if (sin(projection_position.y*5.5)*cos(projection_position.z*5.5)>0.0) Final_Color=vec4 (0.0);

// soft shadow mapping
float shadow=1.0;
float divv=(ShadowPosZ.z+0.000)/ShadowPosZ.w;
if (ShadowPosZ.w>0.0)
{
	for (int t=0;t<4;t++)
	for (int r=0;r<4;r++)
	{
	float Shadow=texture2D (texture2d_2,projection_pos.st+float2 (-0.001*float (r),-0.001*float (t))).z;
	if (0.00102 +Shadow<divv) shadow*=0.936;
	}
}
//Final_Color=vec4 (0.2+shadow);
//Final_Color=vec4 (0.9);

//shadow=1.0;
// texture mapping
float ftex=tex2D (texture2d_3,UVcoordinates.xy*40.2+vec2 (PosY,0.0)).x;
//Final_Color*=ftex;
//Final_Color*=tex2D (texture2d_3,UVcoordinates.xy*11.2+float2 (0.5,0.5));

// projection of spot light onto scene (with texture on top)
float2 ftex2=tex2D (texture2d_3,UVcoordinates.xy*0.2+float2 (0.5,0.5)).xy;
//Final_Color*=tex2D (texture2d_blob,projection_from_camera.st)*13.0;

// normal
float4 TheNormal=(nnormal.xyzz+float4 (1.0))*0.5;
//TheNormal.w=shadow;
TheNormal.w=1.0;



// Back facing culling etc.
if (!gl_FrontFacing) 
{
	//Final_Color=vec4 (1.0,0.0,0.0,1.0);
//TheNormal.w=0.0;
}

//Final_Color=vec4 (0.0,1.0,0.0,1.0);
//Final_Color=vec4 (10.0/projection_from_camera.w,0.0,0.0,1.0);
//TheNormal=vec4 (10.0/projection_from_camera.w,0.0,0.0,1.0);
//Final_Color=TheNormal.xyzz*shadow;
//Final_Color=TheNormal.xyzz*shadow;
Final_Color=vec4 (1.0)*0.0;
//Final_Color*=shadow;
//float ff=

float ff=0.5+0.5*sin (Fade*0.01);
//ff=1.0;
TheNormal=vec4 (0.18,0.1,0.09,1.0)*ff;
TheNormal=vec4 (0.1,0.12,0.13,1.0)*0.3;


//TheNormal.x=projection_position.z*0.2;

//TheNormal*=Fade*3.0;
TheNormal=vec4 (63*pow(1.0/projection_from_camera.z,2.0))*0.3;;



Final_Color=TheNormal*TheColor.xyzz;
Final_Color=vec4 (0.3,0.4,0.3,1.0);

//(0.12,0.1,0.1,1.0);
//TheNormal=vec4 (oUV.x,oUV.y,0.0,0.0)*10.0;


TheNormal=normal.xyzz;
TheNormal=(nnormal.xyzz+float4 (1.0))*0.5;

Final_Color=TheNormal.yxzz+vec4 (1.0);
Final_Color=0.3*vec4 (1.0,0.6,0.4,1.0);

//Final_Color*=1.0-length (gl_PointCoord.xy-vec2(0.5));



gl_FragData[0]=TheNormal;

//gl_FragDepth=0.2;
// cube mapping
//Final_Color*=texture (texture2d_cube,nnormal.xyz+projection_position.xyz);
//Final_Color*=shadow;
//Final_Color=vec4 (1.0,1.0,0.0,1.0);
//Final_Color=(normal2.xyzz+0.5)*0.5;

//Final_Color.w=1.0;
gl_FragData[1]=Final_Color;

// Depth fragment 
///gl_FragDepth=gl_FragCoord.z+0.02*ftex;
}














